<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="仓库编号" prop="storeCode">
              <el-input v-model="queryParams.storeCode" placeholder="请输入仓库编号" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="仓库名称" prop="storeName">
              <el-input v-model="queryParams.storeName" placeholder="请输入仓库名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="是否标识" prop="isFlag">
              <el-select v-model="queryParams.isFlag" placeholder="请选择是否标识" clearable>
                <el-option v-for="dict in wcs_is_flag" :key="dict.value" :label="dict.label" :value="parseInt(dict.value)"/>
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['wcs:storeInfo:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['wcs:storeInfo:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['wcs:storeInfo:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['wcs:storeInfo:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="storeInfoList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="序号" align="center" type="index" width="60" />
        <el-table-column label="仓库编号" align="center" prop="storeCode" />
        <el-table-column label="仓库名称" align="center" prop="storeName" />
        <el-table-column label="是否标识" align="center" prop="isFlag">
          <template #default="scope">
            <dict-tag :options="wcs_is_flag" :value="scope.row.isFlag"/>
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center" prop="remark" />
        <el-table-column label="创建时间" align="center" prop="createTime" width="100">
          <template #default="scope">
            <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="创建人" align="center" prop="createByName" width="100" />
        <el-table-column label="更新人" align="center" prop="updateByName" width="100" />
        <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width" width="120">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['wcs:storeInfo:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['wcs:storeInfo:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>

    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="storeInfoFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="仓库编号" prop="storeCode">
          <el-input v-model="form.storeCode" placeholder="请输入仓库编号" />
        </el-form-item>
        <el-form-item label="仓库名称" prop="storeName">
          <el-input v-model="form.storeName" placeholder="请输入仓库名称" />
        </el-form-item>
        <el-form-item label="是否标识" prop="isFlag">
          <el-radio-group v-model="form.isFlag">
            <el-radio v-for="dict in wcs_is_flag" :key="dict.value" :value="parseInt(dict.value)">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="StoreInfo" lang="ts">
import { listStoreInfo, getStoreInfo, delStoreInfo, addStoreInfo, updateStoreInfo } from '@/api/wcs/storeInfo';
import { StoreInfoVO, StoreInfoQuery, StoreInfoForm } from '@/api/wcs/storeInfo/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { wcs_is_flag } = toRefs<any>(proxy?.useDict('wcs_is_flag'));

const storeInfoList = ref<StoreInfoVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const storeInfoFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: StoreInfoForm = {
  objId: undefined,
  storeCode: undefined,
  storeName: undefined,
  isFlag: 1,
  remark: undefined,
}
const data = reactive<PageData<StoreInfoForm, StoreInfoQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    storeCode: undefined,
    storeName: undefined,
    isFlag: undefined,
    params: {}
  },
  rules: {
    storeCode: [
      { required: true, message: "仓库编号不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

const getList = async () => {
  loading.value = true;
  const res = await listStoreInfo(queryParams.value);
  storeInfoList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

const cancel = () => {
  reset();
  dialog.visible = false;
}

const reset = () => {
  form.value = { ...initFormData, isFlag: 1 };
  storeInfoFormRef.value?.resetFields();
}

const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

const handleSelectionChange = (selection: StoreInfoVO[]) => {
  ids.value = selection.map(item => item.objId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加仓库信息";
}

const handleUpdate = async (row?: StoreInfoVO) => {
  reset();
  const _objId = row?.objId || ids.value[0]
  const res = await getStoreInfo(_objId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改仓库信息";
}

const submitForm = () => {
  storeInfoFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.objId) {
        await updateStoreInfo(form.value).finally(() => buttonLoading.value = false);
      } else {
        await addStoreInfo(form.value).finally(() => buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

const handleDelete = async (row?: StoreInfoVO) => {
  const _objIds = row?.objId || ids.value;
  try {
    await proxy?.$modal.confirm('是否确认删除仓库信息编号为"' + _objIds + '"的数据项？');
    await delStoreInfo(_objIds);
    proxy?.$modal.msgSuccess("删除成功");
    await getList();
  } catch (e) {
    if (e !== 'cancel' && e !== 'close') {
      console.error('删除仓库信息失败', e);
    }
  }
}

const handleExport = () => {
  proxy?.download('wcs/storeInfo/export', {
    ...queryParams.value
  }, `storeInfo_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
